# Awesome Joomla! [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome)

> A curated list of awesome Joomla! resources by [@anibalhsanchez](https://twitter.com/anibal_sanchez) [https://blog.anibalhsanchez.com](https://blog.anibalhsanchez.com)

Awesome list of Joomla! seed repos, starters, boilerplates, examples, tutorials, components, modules, videos, and anything else in Joomla! community. All references are mainly coming from my personal bookmarks and suggestions. Feel free to send me new additions.

Aweseome Joomla! Guidelines:

- Joomla! has more than 10 years of history. So, there are many many many resources. Please, submit only links with up-to-date information.

## Contents

- [Joomla In A Nutshell](#joomla-in-a-nutshell)
- [Top Extensions](#top-extensions)
- [Joomla! Extensions Directory (JED)](#joomla-extensions-directory-jed)
- [Development](#development)
- [Official Resources](#official-resources)
- [Joomla Official Sites](#community-sites)
- [Events](#events)
- [Leadership](#leadership)
- [Marketing](#marketing)
- [Podcasts](#podcasts)
- [Archive](#archive)

## Joomla In A Nutshell

- [Joomla](https://en.wikipedia.org/wiki/Joomla). From Wikipedia: _Joomla is a free and open-source content management system (CMS) for publishing web content. It is built on a model–view–controller web application framework that can be used independently of the CMS._

### Current Joomla! version

- [Joomla! Downloads](https://downloads.joomla.org/)
    - Download Joomla! Stable
    - Upgrade Packages
- [Usage Statistics](https://developer.joomla.org/about/stats.html)
- [Unofficial - Joomla Core Files Mirror](https://mirror.myjoomla.io/) - The oldest, most complete, most respected mirror of all Joomla and Mambo versions ever compiled and maintained.

## Top Extensions

These extensions are always found in any Joomla! site. For more extensions, search the [Joomla! Extensions Directory (JED)](https://extensions.joomla.org).

- [Akeeba Backup](https://extensions.joomla.org/extensions/extension/access-a-security/site-security/akeeba-backup/) and [Admin Tools](https://extensions.joomla.org/extensions/extension/access-a-security/site-security/admin-tools/) - Essential backup and administration tools
- [AcyMailing Starter](https://extensions.joomla.org/extensions/extension/marketing/newsletter/acymailing-starter/) - A well-known extension for mailing
- [Advanced Module Manager](https://extensions.joomla.org/extensions/extension/style-a-design/modules-management/advanced-module-manager/) - Beyond the standard Module Manager, with many powerful features.

## Extensions by Category

- [Photos & Images](https://extensions.joomla.org/category/photos-a-images)
- [Social Web](https://extensions.joomla.org/category/social-web)
- [News Display](https://extensions.joomla.org/category/news-display)
- [Style & Design](https://extensions.joomla.org/category/style-a-design)
- [Site Management](https://extensions.joomla.org/category/site-management)
- [Contacts & Feedback](https://extensions.joomla.org/category/contacts-and-feedback)
- [Structure & Navigation](https://extensions.joomla.org/category/structure-a-navigation)
- [Core Enhancements](https://extensions.joomla.org/category/core-enhancements)
- [e-Commerce](https://extensions.joomla.org/category/e-commerce)
- [Directory & Documentation](https://extensions.joomla.org/category/directory-a-documentation)

To browse the whole catalog of extensions, please, visit the extension directory here, [JED](https://extensions.joomla.org/).

- [Extensions Compatible with J4 Alpha](https://extensions.joomla.org/extensions/extension/?searchall=&filter%5Btags%5D%5B%5D=&filter%5Bcore_catid%5D=&filter%5Bincludes%5D=&filter%5Bversions%5D=40&filter%5Btype%5D=&filter%5Bhasdemo%5D=&filter%5Bnewupdated%5D=&filter%5Bscore%5D=&dir=DESC&limitstart=&controller=filter&view=extension&layout=list&Itemid=145&clearorders=0&clearfilters=1) - Extensions ready for Joomla 4.
- [Custom Fields for Joomla](https://extensions.joomla.org/extensions/extension/?searchall=&filter%5Btags%5D%5B%5D=517&filter%5Bcore_catid%5D=&filter%5Bincludes%5D=&filter%5Bversions%5D=&filter%5Btype%5D=&filter%5Bhasdemo%5D=&filter%5Bnewupdated%5D=&filter%5Bscore%5D=&dir=DESC&limitstart=&controller=filter&view=extension&layout=list&Itemid=145&clearorders=0&clearfilters=1) - New Custom Fields in the Joomla! Extension Directory (JED).

## Development

### Source Code

- [joomla/joomla-cms - Main Repository](https://github.com/joomla/joomla-cms) - Home of the Joomla! Content Management System

### Development Frameworks

- [FOF (Framework on Framework)](https://github.com/akeeba/fof) - FOF (Framework on Framework) is a Rapid Application Development framework for Joomla!.
- [Javascript Frameworks](https://docs.joomla.org/J3.x:Javascript_Frameworks) - The Joomla! CMS includes a number of JavaScript Frameworks.
- [Joomla! Framework](https://framework.joomla.org/) - Designed by software developers for software developers. Easy to Adapt. Easy to Extend.
- [Joomlatools Framework](https://www.joomlatools.com/developer/framework/) - All of Joomlatools extensions are powered by the Joomlatools Framework.

### DevOps, Continuous Integration and Development Toolbox

- [JAB17 - Your Joomla dev-ops, ci & cd toolbox](https://www.youtube.com/watch?v=H5JgIQTLoO0&t=492s) - By Andy Gaskell. This talk will provide a gourmet buffet of information and ideas for dev-ops, continuous integration and continuous deployment.
- [JD17UK - DevOps for Joomla](https://www.youtube.com/watch?v=w5ORPXt6W_o&feature=youtu.be) - By Andy Gaskell. The talk is about DevOps for Joomla, from a practical perspective.
- [AndyGaskell/Joomla_Day_UK_2017](https://github.com/AndyGaskell/Joomla_Day_UK_2017) - Slides and examples from Joomla Day UK 2017
- [Devops with Lando and Docker](https://extly.tech/media/devops-with-lando-and-docker/index.html#/) - By Anibal Sanchez. Introduction to Lando and Docker, in a Joomla context.

### Extension Development

- [joomla-extensions/boilerplate](https://github.com/joomla-extensions/boilerplate) - Boilerplate files for Joomla! extensions
- [joomla-extensions/weblinks](https://github.com/joomla-extensions/weblinks) - This repo is meant to hold the decoupled com_weblinks component and related code.

#### Template Frameworks

There are many templates. So, the topic of "Templates Frameworks" seems to be the right way to name the family of the best templates around.

- [Gantry - Next Generation Theme Framework](http://gantry.org/) - Develop CMS themes quickly and efficiently while providing flexibility and ease-of-use for end-users.
- [T3 for Joomla!](http://www.t3-framework.org/) - The all new, modern and flexible Joomla Template Framework built with Bootstrap 3.

### Testing

- [Testing Joomla! patches](https://docs.joomla.org/Testing_Joomla!_patches)
- [Testing Joomla! patches QuickReferenceGuide](https://docs.joomla.org/Testing_Joomla!_patches_QuickReferenceGuide)
- [Codeception for Joomla!](http://codeception.com/for/joomla) - Combine all testing levels (acceptance, functional, unit).
- [JAB16 - Beyond Testing, by Michael Bodnarchuk](https://www.youtube.com/watch?v=YBL2sN-Bj7g&t=194s) - What are best practices for tests (with code samples).
- [Running Automated Tests for the Joomla CMS](https://docs.joomla.org/Running_Automated_Tests_for_the_Joomla_CMS)

### Extension Development for JED submission

- Most Common Submission Errors
    - Install name doesn't match listing name.
    - Use the [JED Checker](https://extensions.joomla.org/extensions/extension/miscellaneous/development/jedchecker/) tool to screen your extension before resubmitting.
    - [Submission Error Codes](https://extensions.joomla.org/support/knowledgebase/item/submission-error-codes/)

### Administration

- [How do you recover or reset your admin password?](https://docs.joomla.org/How_do_you_recover_or_reset_your_admin_password%3F)
- [Security Checklist/You have been hacked or defaced](https://docs.joomla.org/Security_Checklist/You_have_been_hacked_or_defaced) - On Line Action List.

### Coding standard

- [Joomla! Developer Network - Coding standard](https://developer.joomla.org/coding-standards)
- [Joomla CodeSniffer (PHP CS 1.5.6)](https://docs.joomla.org/Joomla_CodeSniffer#1._Installation_of_PHP_Code_Sniffer_.28phpcs.29) - Legacy - 1.x - <https://github.com/joomla/coding-standards/tree/1.x>
- [Joomla CodeSniffer - (PHP CS 2.8)](https://github.com/joomla/coding-standards) - Modern 2.0.0-alpha

### Tips and Tricks

A handy reference for beginners.

- [Accessing the database using JDatabase](https://docs.joomla.org/How_to_use_the_database_classes_in_your_script)- [Retrieving request data using JInput](https://docs.joomla.org/Retrieving_request_data_using_JInput)
- [Adding JavaScript and CSS to the page](https://docs.joomla.org/Adding_JavaScript_and_CSS_to_the_page)
- [Understanding Output Overrides](https://docs.joomla.org/Understanding_Output_Overrides) - A Personal Note: This is VERY important to master the art of customizing a site.

### Joomla 4 Resources

#### General Resources for J4

- [Potential backward compatibility issues in Joomla 4](https://docs.joomla.org/Potential_backward_compatibility_issues_in_Joomla_4) - This document tracks potential backward compatibility issues for Joomla! 4. Listed are issues which potentially break extensions.
- [Joomla 4 Readiness Survey - December 21st 2017](https://docs.google.com/forms/d/1VNNe77rEFMKtK0oT9ZVKi17ZhHC8iVwj1GNM3XMlNgg/viewanalytics?edit_requested=true)
- [Joomla - Nightly Builds](https://developer.joomla.org/nightly-builds.html) - Help test the latest Joomla! code.
- [Testing Joomla! patches](https://docs.joomla.org/Testing_Joomla!_patches) - This page explains how you can contribute to the Joomla project by testing
- [Testing Joomla! patches QuickReferenceGuide](https://docs.joomla.org/Testing_Joomla!_patches_QuickReferenceGuide) - A Quick Reference Guide for testing
- [Ruud68 - coding-standards/Joomla/Sniffs](https://github.com/Ruud68/coding-standards/tree/master/Joomla/Sniffs/Deprecated) - A whole bunch of depreacted functions and classes
- [Joomla 4 - Roadmap](https://developer.joomla.org/roadmap.html#4) - The full Joomla 4 roadmap is published on the Developer site.

#### Videos about Joomla 4

- [JWC 2017 - Joomla 4 - Coming to a Website near you!](https://www.youtube.com/watch?v=1UKh8RmWTrI&list=PL0Lg2fzcJu1Rk-Ylwo1kKNZvY_Pz8yhW0&index=9), by George Wilson
- [JWC 2017 - Joomla 4ward](https://www.youtube.com/watch?v=uT05Co1hqDA&list=PL0Lg2fzcJu1Rk-Ylwo1kKNZvY_Pz8yhW0&index=23), by Michael Babker
- [JAB17 - New authorization library in J4 - redone for performance and flexybility](https://www.youtube.com/watch?v=XwX_dYpZw5k&index=3&list=PLSwFVRVZ3joRaNi8VgagcqW4IxX5MmYOc), by Klas - All about new authorization library is replacing JAccess in J4.
- [JAB17 - Prepare your extension for Joomla 4](https://www.youtube.com/watch?v=4FKSrAVcDqU&list=PLSwFVRVZ3joRaNi8VgagcqW4IxX5MmYOc&index=6), by Allon Moritz. Allon leads the media manager team and is porting the Joomla CMS to namespaces in the Joomla 4 working group.

#### New Media Manager

- [Joomla 4 New Media Manager: How it helps manage media files](https://www.gavick.com/blog/joomla-4-new-media-manager-how-it-helps-manage-media-files)

#### New User Interface of J4

- [Bootstrap v4.0 - Documentation](http://getbootstrap.com/docs/4.0/getting-started/introduction/)
- [Be smart, load but don’t unload!](https://developer.joomla.org/news/716-be-smart-load-but-dont-unload-ui-frameworks.html) - Information to our users / Joomla and UI Frameworks
- [Episode IV - A new User Interface for the Joomla Backend](https://magazine.joomla.org/item/3289-episode-iv-a-new-user-interface-for-the-joomla-backend)
- [Joomla 4 - Custom Elements](https://magazine.joomla.org/issues/issue-nov-2017/item/3286-joomla-4-custom-elements), by Dimitris Grammatikogiannis
- [Joomla 4 and Bootstrap 4: Perfect integration](https://www.jomsocial.com/blog/joomla-4-and-bootstrap-4-perfect-integration)

#### PHP 7 - Minimum Requirement

- [4 reasons why you should get PHP 7](https://www.joomla.org/announcements/general-news/5719-4-reasons-why-you-should-get-php-7.html). Be ready for #Joomla 4. It's coming in 2018

#### Community News about Joomla 4

- [Joomla 4 compatibility layer in 3.8](https://developer.joomla.org/news/717-joomla-4-compatibility-layer-in-3-8.html) - With the release of Joomla 3.8 a first compatibility layer for Joomla 4 was released.
- [8 most exciting Joomla 4 new features](https://www.joomlart.com/blog/8-most-excited-joomla-4-new-features)
- [9 exciting Joomla 4 new features introduction](https://www.joomlart.com/blog/infographic-9-exiting-joomla-4-new-features-introduction)
- [A First Look at Joomla 4](https://www.joomlashack.com/blog/tutorials/first-look-joomla-4/)
- [Discovery Joomla 4 News Features and Release Plan](https://www.smartaddons.com/blog/discovery-joomla-4-news-features-and-release-plan)
- [Everything you need to know about Joomla 4](https://www.joomshaper.com/blog/everything-you-need-to-know-about-joomla-4)
- [Joomla 3 and Joomla 4 features comparison: 15 new things to take note](https://www.joomlart.com/blog/joomla-3-vs-joomla-4-features-comparison-15-new-things-to-take-note)
- [Joomla 4 Alpha is Out! Check the extensions for compatibility Joomla](https://magazine.joomla.org/item/3290-joomla-4-alpha-is-out)
- _Podcast Español_ - [Mastermind Joomla - ¿Qué esperar de Joomla 4?](https://mastermindjoomla.com/17-que-esperar-joomla-4)

![9 exciting Joomla 4 new features introduction](https://static.joomlart.com/images/blog/2017/joomla-4/joomla-4-new-features-infographics/joomla-4-new-features-infographics.jpg)

## Official Resources

- [Joomla! - Main Site](https://www.joomla.org/)
- [Joomla! Volunteers Portal™](https://volunteers.joomla.org/)
    - [Board of Directors - Reports](https://volunteers.joomla.org/board-of-directors)
    - [Departments - Reports](https://volunteers.joomla.org/departments)
        - [Events](https://volunteers.joomla.org/departments/events)
        - [Legal & Financial](https://volunteers.joomla.org/departments/legal-financial)
        - [Marketing & Communication](https://volunteers.joomla.org/departments/marketing-communication)
        - [Operations](https://volunteers.joomla.org/departments/operations)
        - [Production](https://volunteers.joomla.org/departments/production)
        - [Programs](https://volunteers.joomla.org/departments/programs)
- [Advertise on Joomla! | BuySellAds](https://www.buysellads.com/buy/detail/278743)

## Joomla Official Sites

- Main Site - [www.joomla.org](https://www.joomla.org)
- Joomla! API - [api.joomla.org](https://api.joomla.org)
- Joomla! Certification Program - [certification.joomla.org](https://certification.joomla.org)
- The Joomla! Community Portal - [community.joomla.org](https://community.joomla.org)
- Joomla! World Conference - [conference.joomla.org](https://conference.joomla.org)
- Joomla! Developer Network - [developer.joomla.org](https://developer.joomla.org)
- Joomla! Documentation - [docs.joomla.org](https://docs.joomla.org)
- Joomla! Downloads - [downloads.joomla.org](https://downloads.joomla.org)
- Joomla! Certification Exam - [exam.joomla.org](https://exam.joomla.org)
- Joomla! Extensions Directory - [extensions.joomla.org](https://extensions.joomla.org)
- The Joomla! Forum - [forum.joomla.org](https://forum.joomla.org)
- Joomla! Framework - [framework.joomla.org](https://framework.joomla.org)
- Joomla! Issue Tracker - [issues.joomla.org](https://issues.joomla.org)
- Joomla! Community Magazine - [magazine.joomla.org](https://magazine.joomla.org)
- Open Source Matters! - [opensourcematters.org](http://opensourcematters.org)
- Joomla! Resources Directory - [resources.joomla.org](http://resources.joomla.org)
- Joomla! Showcase Directory - [showcase.joomla.org](https://showcase.joomla.org)
- Joomla! Trademark & Licensing - [tm.joomla.org](https://tm.joomla.org)
- The Joomla! Vulnerable Extensions List - [vel.joomla.org](https://vel.joomla.org)
- Joomla! Volunteers Portal - [volunteers.joomla.org](https://volunteers.joomla.org)
- JoomlaCode - [joomlacode.org](http://joomlacode.org)

## Events

- [Joomla! World Conference](https://conference.joomla.org/) - The official main event
- [J and Beyond](http://jandbeyond.org/) - The community main event
- [Joomla! Days](https://community.joomla.org/events/joomladays.html) - Joomla Days are local events, coordinated by user groups at city level.

## Leadership

### Organization Chart

![Organization Chart](https://community.joomla.org/images/blogs/leadership-blog/joomla_leadership_structure.png)

### Teams

- Events
    - Events
    - User Groups (JUG)
    - World Conference (JWC)
- Legal & Finance
    - Capital
    - Finance Team (FIT)
    - Trademark & Licensing (TLWG)
- Marketing & Communication
    - Community Translation
    - Marketing
    - Social Media
- Operations
    - Community Magazine (JCM)
    - Extensions Directory (JED)
    - Forum
    - Resources Directory (JRD)
    - Showcase Directory (JSD)
    - Template Directory (JTD)
    - Vulnerable Extensions List (VEL)
- Production
    - Automated Testing
    - Bug Squad
    - CMS Maintainance
    - CMS Release
    - Core Translation
    - Documentation (JDOCS)
    - Framework
    - Google Summer of Code (GSOC)
    - Joomla! X
    - Security Strike Team (SST)
    - User Experience (JUX)
- Programs
    - Certification
    - Event Traveller Program (JET)

### Joomla! Board of Directors

- [President - Robert Jacobi](http://example.com)
- [Vice-President - Aleksander Kuczek](http://example.com)
- [Secretary - Luca Marzo](http://example.com)

#### Department Coordinators

- [Production - Michael Babker](https://twitter.com/mbabker)
- [Treasurer - Mike Demopoulos](https://twitter.com/mpmike)
- [Operations - Peter Martin](http://twitter.com/pe7er)
- [Marketing & Communication - Radek Suski](https://twitter.com/RadekSu)
- [Events - Rowan Hoskyns Abrahall](https://volunteers.joomla.org/joomlers/677-rowan-hoskyns-abrahall)
- [Legal & Finance - Søren Beck Jensen](https://twitter.com/sorenbeck)
- [Programs - Yves Hoppe](https://twitter.com/yveshoppe)

## Marketing

- [Brochure - 2017](https://github.com/anibalsanchez/awesome-joomla/blob/master/Joomla_Brochure-UseCases-2017-US-English-2-opt.pdf). High-level informative document.
- [Media Kit](https://docs.google.com/document/d/1EU_d_-uae2lHA-IbvnXJo5h6ZBK84tUO0-Xx7lC0qm0/edit#). Promotional Materials about Joomla.
    - Key Facts
        - Joomla is an award-winning content management system (CMS) used to build powerful web sites and online applications.
        - A global volunteer community of developers has been building and improving Joomla since the first version was released in 2005. This immense effort has made _Joomla easy to use, stable and very secure_.
        - Joomla is an award-winning content management system (CMS). During 2017, Joomla won the **Best Free CMS**, by [2017 CMS Critic Awards](https://community.joomla.org/blogs/community/joomla-is-the-best-free-cms-by-2017-cms-critic-awards.html)
        - Within the main functionality,"ease of use" and "extensibility" (8,000+ approved extensions) are always highlighted. This is the core functionality: <https://www.joomla.org/core-features.html>. Natively, Joomla incorporates 2FA authentication.
        - Joomla is an established CMS, with a mature code base (370,000+ lines of code), more than 12 years of evolution (29,000+ commits) and supported by a great team of collaborators (780+).
        - Joomla is used in 6.6% of CMS and 3.2% of global websites.
    - Key Numbers
        - 6.5% of the websites built with a CMS. 3.2% of all websites
        - 2+ million websites
        - 90+ million downloads
        - 370,000+ lines of code
        - 29,000+ commits
        - 780+ core developers
        - 10+ core extensions
        - 170+ User Groups
        - 70+ Events per year
        - 1,200+ registered volunteers
        - 25 million sessions in 2017
In particular, security is a strength of Joomla:
    - Joomla has the [Best Practice Guides](https://developer.joomla.org/coding-standards.html) in its development standard and is a measure that applies to core development and approved extensions within the ecosystem.
To confirm Joomla's security assurances in perspective, Joomla had 94 security reports, while WordPress had 254 and Drupal 313 respectively. You can find the full analysis here: https://www.getastra.com/blog/cms/security-comparison-of-cms-wordpress-vs-drupal-vs-joomla/
    - In short, Joomla is ideal for corporate sites, non-profit organisations, or educational institutions.
    - About the news in 2017, this is a good summary of the day-to-day topics of the project: https://www.joomla.org/announcements/general-news/5722-joomla-year-in-review-2017.html
- [A sustainable ecosystem for Joomla](https://docs.google.com/presentation/d/1Sx1UPZ8whxsxFvyHCMoGhtF5_HvHH1Xy3QWJe3EeCcE/edit#slide=id.g1ba30ac4d2_0_6)
- [Joomla Marketing Visuals](https://docs.joomla.org/Joomla_Marketing_Visuals) - [Google Drive](http://goo.gl/VRlZCP)
- [Joomla Signature](https://drive.google.com/drive/folders/0B-WMsfRg_wiva0ZIMUtNNWVIVnM)
- [Joomla Brandmark](https://drive.google.com/drive/folders/0B-WMsfRg_wivamdtTnppRkpFMmM)
- [Official Colours](https://drive.google.com/drive/folders/0B-WMsfRg_wivZVRST29TMUQ3blk)
- [Typography](https://drive.google.com/drive/folders/0B-WMsfRg_wivMVp2T0V4VU5EOW8)
- [Logos - Conditional Use](https://drive.google.com/drive/folders/0B0yY6xU4qDVUaVdoXzlHeHZMeTg)
- [Joomla 3.6 Imagery](https://docs.joomla.org/J3.x:Joomla_3.6_Imagery)
- [Social Media - Joomla 3.5](https://drive.google.com/drive/folders/0B5uNo3ban2UnN05UYUh6M1hXVmM)

## Podcasts

- [Joomla Beat Podcast | Spreaker](https://www.spreaker.com/show/joomla_beat_podcast)
- [Mastermind Joomla!](https://mastermindjoomla.com/) - _Español_

## Archive

List of archived Joomla! sub-projects, unsupported or longer active:

- [What version of Joomla! should you use?](https://docs.joomla.org/What_version_of_Joomla!_should_you_use%3F) Joomla! 1.0, 1.5, 1.6, 1.7 and 2.5.
- [API16:Framework](https://docs.joomla.org/API16:Framework) - The Joomla! Framework was an important part of the Joomla! CMS architecture in the versions 1.5 and 1.6. Do NOT confuse with the current JFramework (Yes, I know ...).
- [JPlatform](https://docs.joomla.org/Platform) - As of 24 April 2013, the Platform project has been retired. The Platform has been merged back into the CMS.

## Contribute

Contributions welcome! Read the [contribution guidelines](contributing.md) first.

## License

[![CC0](http://mirrors.creativecommons.org/presskit/buttons/88x31/svg/cc-zero.svg)](http://creativecommons.org/publicdomain/zero/1.0)

To the extent possible under law, Anibal Sanchez has waived all copyright and
related or neighboring rights to this work.
